SystemOrganization addCategory: #GODProcessorsTests!

TestCase subclass: #PCSStatisticsTests
	instanceVariableNames: 'pcsStatistics aCollection aGODCollection invalidCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODProcessorsTests'!

!PCSStatisticsTests methodsFor: 'initialize-release' stamp: 'TD 10/7/2014 19:41'!
setUp
	"Define local objects for tests"
	|godData|
	pcsStatistics := PCSStatisticsCalculator new.
	aCollection = #(1 3 3 4 4).
	invalidCollection = #(1 3 a 4 4).
	aGODCollection := Set new.
	godData := GODData new.
	godData
		title: 'title1';
		width: 1.
	aGODCollection add: godData.
	godData := GODData new.
	godData
		title: 'title2';
		width: 2.
	aGODCollection add: godData.
	godData := GODData new.
	godData
		title: 'title3';
		width: 3.
	aGODCollection add: godData.
		
! !

!PCSStatisticsTests methodsFor: 'tests' stamp: 'TD 10/7/2014 19:02'!
testAverage
	"test average"
	self assert: (pcsStatistics average: aCollection) = 3.
	! !

!PCSStatisticsTests methodsFor: 'tests' stamp: 'TD 10/7/2014 19:15'!
testAverageKey
	"test average given the key width"
	self assert: (pcsStatistics average: aGODCollection key: [:x | x width]) = 2.
	! !

!PCSStatisticsTests methodsFor: 'tests' stamp: 'TD 10/7/2014 19:41'!
testNaN
	self should: [pcsStatistics average: invalidCollection.] raise: Error! !
